<template>
  <q-card flat bordered class="items-start col">
    <q-card-section class="q-pa-md" horizontal>
      <div class="text-h6">Nueva Pregunta</div>
      <q-space />
      <q-btn label="Editar" v-if="disabled" v-on:click="makeEditable" color="negative"/>
    </q-card-section>
    <q-separator inset />
    <q-form
      v-on:submit="onSubmit"
      v-on:reset="onReset"
      class="q-gutter-md"
    >
      <q-card-section class="q-pa-md" horizontal>
        <q-card-section class="col">
          <div class="text-subtitle2">Pregunta</div>
          <editor-kitchen-sink
            v-bind:qeditor="question"
            v-on:update-model="questionUpdated"
            v-bind:rules="[ val => val && val.length > 0 || 'Ingrese una pregunta, por favor.']"
            v-bind:disable="disabled"
          />
          <q-select
            outlined
            v-model="tags"
            v-bind:options="suggestions"
            option-value="label"
            v-on:filter="filterFn"
            v-bind:options-sanitize="true"
            new-value-mode="add-unique"
            multiple
            use-input
            use-chips
            hide-dropdown-icon
            clearable
            hide-hint
            label="Añada etiquetas a su pregunta *"
            hint="Escriba una asignatura, nivel, contenido u otro identificador y presione enter. Puede ingresar cuantas quiera."
            lazy-rules
            v-bind:rules="[ val => val && val.length > 0 || 'Ingrese una etiqueta, por favor.']"
          />
          <div class="text-body1">Tipo de pregunta: {{ tipo }}</div>
          <q-card-actions>
            <q-btn label="Registrar" type="submit" color="primary" v-bind:loading="workState"/>
            <q-btn label="Cancelar" type="reset" color="primary" flat class="q-ml-sm" />
          </q-card-actions>
        </q-card-section>
        <q-card-section class="col column justify-start">
          <div class="q-pa-md q-gutter-xs">
            <q-btn v-bind:disable="disabled" label="Añadir nueva respuesta" v-on:click="addAnswer" color="primary"/>
            <q-btn label="Remover última respuesta" v-on:click="removeAnswer" color="secondary" v-bind:disable="disabled || answers.length <= 1"/>
          </div>
          <div
            v-for="(answer, index) in answers"
            v-bind:key="index"
          >
            <q-input
              outlined
              v-model="answer.textAnswer"
              label="Texto de su respuesta *"
              v-bind:hint="'Respuesta ' + index + ' para su pregunta'"
              v-bind:disable="disabled"
              hide-hint
              lazy-rules
              v-on:keydown.enter.prevent="addAnswer"
              v-bind:rules="[ val => val && val.length > 0 || 'Ingrese una pregunta, por favor.']"
            />
            <q-toggle v-bind:disable="disabled" v-model="answer.correct" label="Respuesta correcta o complementaria." />
          </div>
          <div v-if="pointsLeft">
            <q-badge color="secondary">
              Puntaje: {{ points }} (1 to {{ pointsLeft}})
            </q-badge>
            <q-slider v-bind:min="1" v-bind:max="pointsLeft" v-model="points" snap label color="negative" />
          </div>
        </q-card-section>
      </q-card-section>
    </q-form>
  </q-card>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'QuestionCardCreation',
  components: {
    EditorKitchenSink: () => import('../EditorKitchenSink')
  },
  props: ['options', 'defaultTags', 'pointsLeft', 'pointsUsed', 'defaultQuestion'],
  data () {
    return {
      suggestions: this.options,
      disabled: false,
      id: null,
      originalQuestionId: null,
      question: '',
      tipo: 'desarrollo',
      points: this.pointsUsed,
      tags: this.defaultTags,
      answers: [
        {
          textAnswer: '',
          correct: true
        }
      ]
    }
  },
  computed: {
    ...mapGetters({
      userId: 'auth/getId',
      workState: 'current/getWorkState'
    })
  },
  mounted () {
    if (this.defaultQuestion) {
      this.id = this.defaultQuestion.id
      this.question = this.defaultQuestion.question
      this.answers = this.defaultQuestion.answers
      this.tipo = this.defaultQuestion.type
      this.tags = this.defaultTags
      this.disabled = true
    }
  },
  watch: {
    defaultQuestion () {
      this.id = this.defaultQuestion.id
      this.question = this.defaultQuestion.question
      this.answers = this.defaultQuestion.answers
      this.tipo = this.defaultQuestion.type
      this.disabled = true
    },
    defaultTags () {
      this.tags = this.defaultTags
    },
    answers: {
      handler: function () {
        var firstFalse = false
        var firstTrue = false
        var secondTrue = false
        for (var answer of this.answers) {
          if (answer.correct && firstTrue) {
            secondTrue = answer.correct
          } else if (!answer.correct) {
            firstFalse = !answer.correct
          } else {
            firstTrue = answer.correct
          }
        }
        if (!secondTrue && !firstFalse) {
          this.tipo = 'desarrollo'
        } else if (!secondTrue && firstFalse) {
          this.tipo = 'elección'
        } else if (secondTrue && !firstFalse) {
          this.tipo = 'desarrollo largo'
        } else if (secondTrue && firstFalse) {
          this.tipo = 'elección múltiple'
        }
      },
      deep: true
    }
  },
  methods: {
    filterFn (val, update, abort) {
      if (val.length < 2) {
        abort()
        return
      }

      update(() => {
        const needle = val.toLowerCase()
        this.suggestions = this.options.filter(v => v.toLowerCase().indexOf(needle) > -1)
        val = ''
      })
    },
    makeEditable () {
      this.disabled = false
      this.originalQuestionId = this.id
      this.id = null
    },
    addAnswer () {
      this.answers.push({
        textAnswer: '',
        correct: false
      })
    },
    removeAnswer () {
      if (this.answers.length > 1) this.answers.splice(-1, 1)
    },
    questionUpdated (val) {
      this.question = val
    },
    onSubmit () {
      this.$emit('saving', {
        id: this.id,
        originalId: this.originalQuestionId,
        question: this.question,
        type: this.tipo,
        autorId: this.userId,
        tags: this.tags,
        answers: this.answers,
        points: this.points
      }, this.onReset)
    },
    onReset () {
      this.question = ''
      this.id = null
      this.originalQuestionId = null
      this.tipo = 'desarrollo'
      this.tags = this.defaultTags
      this.disabled = false
      this.points = 1
      this.answers = [
        {
          textAnswer: '',
          correct: true
        }
      ]
    }
  }
}
</script>
